diff --git a/packages/visualgst/Widget/Tree.st b/packages/visualgst/Widget/Tree.st
new file mode 100644
index 0000000..6a3115c
--- /dev/null
+++ b/packages/visualgst/Widget/Tree.st
@@ -0,0 +1,168 @@
+"======================================================================
+|
+| Tree class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Tree [
+
+    | tree model |
+
+    Tree class >> column: anArray children: aChildrenOneArgBlock contents: aOneArgBlock [
+        <category: 'instance creation'>
+
+        ^ self new
+            column: anArray children: aChildrenOneArgBlock contents: aOneArgBlock;
+            yourself        
+    ]
+
+    initialize [
+        <category: 'initialization'>
+
+    ]
+
+    column: anArray children: aChildrenOneArgBlock contents: aOneArgBlock [
+        <category: 'initialization'>
+
+        tree := GTK.GtkTreeView createTreeWithModel: anArray.
+        model := GtkTreeModel on: tree getModel.
+        model childrenBlock: aChildrenOneArgBlock.
+        self contents: aOneArgBlock.
+        child := GTK.GtkScrolledWindow withChild: tree.
+        super initialize.
+    ]
+
+    contents: aOneArgBlock [
+
+        model contentsBlock: aOneArgBlock.
+    ]
+
+    item: anObject [
+
+        model item: anObject
+    ]
+
+    refresh [
+
+        model refresh
+    ]
+
+    clear [
+
+        model clear
+    ]
+
+    hasSelection [
+
+        ^ tree getSelection getMode == GTK.Gtk gtkSelectionMultiple 
+                ifTrue: [ (tree getSelection getSelectedRows: nil) ~= nil ]
+                ifFalse: [ tree hasSelectedItem ]
+    ]
+
+    selection [
+
+        ^ tree getSelection getMode == GTK.Gtk gtkSelectionMultiple
+                ifTrue: [ tree selections ]
+                ifFalse: [ tree selection ]
+    ]
+
+    select: anObject [
+
+        ^ tree select: anObject
+    ]
+
+    unselectAll [
+
+        tree unselectAll
+    ]
+
+    noSelection [
+
+        tree getSelection setMode: GTK.Gtk gtkSelectionNone
+    ]
+
+    zeroOrOneSelection [
+
+        tree getSelection setMode: GTK.Gtk gtkSelectionSingle
+    ]
+
+    singleSelection [
+
+        tree getSelection setMode: GTK.Gtk gtkSelectionBrowse
+    ]
+
+    multipleSelection [
+
+        tree getSelection setMode: GTK.Gtk gtkSelectionMultiple
+    ]
+
+    expandAll [
+
+        tree expandAll
+    ]
+
+    popupMenu: aMenuBuilder [
+        <category: 'user interface'>
+
+        popupMenu := aMenuBuilder.
+        tree connectSignal: 'button-press-event' to: self selector: #'onPress:event:'
+    ]
+
+    whenButtonPressedSend: aSymbol to: anObject [
+
+        tree connectSignal: 'button-press-event' to: anObject selector: aSymbol
+    ]
+
+    whenSelectionChangedSend: aSymbol to: anObject [
+
+        tree getSelection connectSignal: 'changed' to: anObject selector: aSymbol
+    ]
+
+    onPress: aGtkWidget event: aGdkEvent [
+        <category: 'button event'>
+
+        | menu aGdkButtonEvent |
+        aGdkButtonEvent := aGdkEvent castTo: GTK.GdkEventButton type.
+        aGdkButtonEvent button value = 3 ifFalse: [ ^ false ].
+        menu := popupMenu asPopupMenu.
+        menu attachToWidget: tree detacher: nil.
+        menu popup: nil parentMenuItem: nil func: nil data: nil button: 3 activateTime: aGdkButtonEvent time value.
+        menu showAll.
+        ^ true
+    ]
+
+    tree [
+
+        ^ tree
+    ]
+]
+
diff --git a/packages/visualgst/Widget/VBox.st b/packages/visualgst/Widget/VBox.st
new file mode 100644
index 0000000..43a893d
--- /dev/null
+++ b/packages/visualgst/Widget/VBox.st
@@ -0,0 +1,44 @@
+"======================================================================
+|
+| VBox class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Box subclass: VBox [
+
+    box [
+        <category: 'accessing'>
+
+        ^ GTK.GtkVBox
+    ]
+]
+
diff --git a/packages/visualgst/Widget/VPaned.st b/packages/visualgst/Widget/VPaned.st
new file mode 100644
index 0000000..e1166c3
--- /dev/null
+++ b/packages/visualgst/Widget/VPaned.st
@@ -0,0 +1,44 @@
+"======================================================================
+|
+| VPaned class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Paned subclass: VPaned [
+
+    paned [
+        <category: 'accessing'>
+
+        ^ GTK.GtkVPaned
+    ]
+]
+
diff --git a/packages/visualgst/Widget/VSidebar.st b/packages/visualgst/Widget/VSidebar.st
new file mode 100644
index 0000000..f3c9ef9
--- /dev/null
+++ b/packages/visualgst/Widget/VSidebar.st
@@ -0,0 +1,43 @@
+"======================================================================
+|
+| VSidebar class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Sidebar subclass: VSidebar [
+
+    panedOrientation [
+
+	^ GTK.GtkVPaned
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Widget.st b/packages/visualgst/Widget/Widget.st
new file mode 100644
index 0000000..594b053
--- /dev/null
+++ b/packages/visualgst/Widget/Widget.st
@@ -0,0 +1,181 @@
+"======================================================================
+|
+| Widget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Object subclass: Widget [
+
+    | child parent parentWindow popupMenu |
+
+    Widget class >> new [
+	<category: 'instance creation'>
+
+        ^ super new
+            initialize;
+            yourself
+    ]
+
+    Widget class >> parentWindow: aGtkWindow [
+	<category: 'instance creation'>
+
+        ^ self new
+            parentWindow: aGtkWindow;
+            yourself
+    ]
+
+    Widget class >> showAll [
+	<category: 'instance creation'>
+
+	^ self new
+	    showAll;
+	    yourself
+    ]
+
+    initialize [
+	<category: 'initialize'>
+
+        self showAll
+    ]
+
+    parent: aWidget [
+        <category: 'accessing'>
+
+        parent := aWidget
+    ]
+
+    parent [
+        <category: 'accessing'>
+
+        ^ parent
+    ]
+
+    parentWindow: aGtkWindow [
+        <category: 'accessing'>
+
+        parentWindow := aGtkWindow
+    ]
+    
+    parentWindow [
+	<category: 'accessing'>
+
+	^ parentWindow
+    ]
+
+    mainWidget [
+	<category: 'accessing'>
+
+	^ child
+    ]
+
+    showAll [
+	<category: 'user interface'>
+
+	child showAll
+    ]
+
+    hideAll [
+	<category: 'user interface'>
+
+	child hideAll
+    ]
+
+    isVisible [
+	<category: 'testing'>
+
+	^ child getVisible
+    ]
+
+    hasFocus [
+	<category: 'testing'>
+
+        | parent current |
+        parent := child.
+        [ (current := parent getFocusChild) notNil ] whileTrue: [
+            parent := current ].
+        ^ self parentWindow getFocus = parent
+
+    ]
+
+    focusedWidget [
+	<category: 'focus'>
+
+        self hasFocus ifTrue: [ ^ self ].
+        ^ nil
+    ]
+
+    onFocusPerform: aSymbol [
+        <category: 'widget'>
+
+        ^ self focusedWidget perform: aSymbol
+    ]
+
+    height [
+
+        ^ child getAllocation height
+    ]
+
+    width [
+
+        ^ child getAllocation width
+    ]
+
+    onPress: aGtkWidget event: aGdkEvent [
+        <category: 'button event'>
+
+        | menu aGdkButtonEvent |
+        aGdkButtonEvent := aGdkEvent castTo: GTK.GdkEventButton type.
+        aGdkButtonEvent button value = 3 ifFalse: [ ^ false ].
+        menu := popupMenu asPopupMenu.
+        menu attachToWidget: self treeView detacher: nil.
+        menu popup: nil parentMenuItem: nil func: nil data: nil button: 3 activateTime: aGdkButtonEvent time value.
+        menu showAll.
+        ^ true
+    ]
+
+    connectToWhenPopupMenu: aMenuBuilder [
+	<category: 'user interface'>
+
+	popupMenu := aMenuBuilder.
+	^ self treeView connectSignal: 'button-press-event' to: self selector: #'onPress:event:'
+    ]
+
+    grabFocus [
+	<category: 'user interface'>
+
+        child grabFocus
+    ]
+
+    close [
+	<category: 'user interface'>
+    ]
+]
diff --git a/packages/visualgst/Widget/Window.st b/packages/visualgst/Widget/Window.st
new file mode 100644
index 0000000..e3f8a4c
--- /dev/null
+++ b/packages/visualgst/Widget/Window.st
@@ -0,0 +1,314 @@
+"======================================================================
+|
+| Window class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Window [
+
+    | window container menuBar toolBar centralWidget statusBar accelGroup central |
+
+    Window class >> open [
+	<category: 'user interface'>
+
+	^ (self new)
+	    initialize;
+	    showAll;
+	    postInitialize;
+	    yourself
+    ]
+
+    Window class >> openSized: aPoint [
+	<category: 'user interface'>
+	
+	^ (self new)
+	    initialize;
+	    resize: aPoint;
+	    showAll;
+	    postInitialize;
+	    yourself
+    ]
+
+    centralWidget [
+	<category: 'accessing'>
+
+	^ centralWidget
+    ]
+
+    centralWidget: aWidget [
+	<category: 'accessing'>
+
+	centralWidget := aWidget mainWidget.
+        central := aWidget.
+        central parent: self
+    ]
+
+    container [
+	<category: 'accessing'>
+
+	^ container ifNil: [ container := GTK.GtkVBox new: false spacing: 0 ]
+    ]
+
+    accelGroup [
+	<category: 'accessing'>
+
+	^ accelGroup ifNil: [ accelGroup := GTK.GtkAccelGroup new ]
+    ]
+
+    menuBar [
+	<category: 'accessing'>
+
+	^ menuBar ifNil: [ menuBar := GTK.GtkMenuBar new ]
+    ]
+
+    menuBar: aGtkMenuBar [
+	<category: 'accessing'>
+
+	menuBar := aGtkMenuBar
+    ]
+
+    statusBar [
+	<category: 'accessing'>
+
+	^ statusBar ifNil: [ statusBar := GTK.GtkStatusbar new ] 
+    ]
+
+    statusBar: aGtkStatusBar [
+	<category: 'accessing'>
+
+	statusBar := aGtkStatusBar
+    ]
+
+    title [
+	<category: 'accessing'>
+
+	^ window title
+    ]
+
+    title: aString [
+	<category: 'accessing'>
+
+	window setTitle: aString
+    ]
+
+    toolBar [
+	<category: 'accessing'>
+
+	^ toolBar ifNil: [ toolBar := GTK.GtkToolbar new ]
+    ]
+
+    toolBar: aGtkToolBar [
+	<category: 'accessing'>
+
+	toolBar := aGtkToolBar
+    ]
+
+    aboutGst [
+	<category: 'events'>
+
+	(GTK.GtkAboutDialog new)
+	    setProgramName: 'GNU Smalltalk';
+	    setVersion: (Smalltalk version =~ 'version (.*)' at: 1);
+	    setLicense: 'GNU Smalltalk is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later version.
+
+GNU Smalltalk is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+details.
+
+You should have received a copy of the GNU General Public License along with
+GNU Smalltalk; see the file COPYING.  If not, write to the Free Software
+Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  
+
+Please consult the GNU Smalltalk source code for additional permissions
+that are specific to this version of GNU Smalltalk.';
+	    setWebsite: 'http://smalltalk.gnu.org/';
+	    showModalDestroy
+    ]
+
+    close [
+	<category: 'events'>
+
+	window hideAll
+    ]
+
+    initialize [
+	<category: 'intialization'>
+	
+	window := GTK.GtkWindow	new: GTK.Gtk gtkWindowToplevel.
+	window addAccelGroup: self accelGroup.
+        self
+            title: self windowTitle;
+            createMenus;
+            createToolbar;
+            createStatusBar;
+            centralWidget: self buildCentralWidget
+    ]
+
+    buildCentralWidget [
+	<category: 'initialization'>
+        ^nil
+    ]
+
+    createStatusBar [
+        <category: 'user interface'>
+
+        self statusMessage: self windowTitle
+    ]
+
+    windowTitle [
+	<category: 'initialization'>
+        ^self class name
+    ]
+
+    createToolbar [
+	<category: 'initialization'>
+    ]
+
+    createMenus [
+	<category: 'initialization'>
+    ]
+
+    postInitialize [
+	<category: 'initialization'>
+
+        window
+            connectSignal: 'delete-event' to: self selector: #'onDelete:event:'
+    ]
+
+    onDelete: aGtkWidget event: aGdkEvent [
+	<category: 'events'>
+
+        window hideAll.
+        ^ true
+    ]
+
+    addMenuItem: aString [
+	<category: 'menubar'>
+
+	self menuBar append: (GTK.GtkMenuItem newWithLabel: aString)
+    ]
+
+    addMenuItem: aString withSubmenu: aGtkMenuItemArray [
+	<category: 'menubar'>
+
+	self menuBar append:
+	    ((GTK.GtkMenuItem newWithLabel: aString)
+		setSubmenu: (self createNewMenuEntry: aGtkMenuItemArray))
+    ]
+
+    createMainMenu: anArray [
+	<category: 'menubar'>
+
+	anArray do: [ :each |
+	    self addMenuItem: each first withSubmenu: (self perform: each second) ]
+    ]
+
+    createNewMenuEntry: anArray [
+        <category: 'menubar'>
+
+        | menu |
+        menu := (GTK.GtkMenu new)
+                    setAccelGroup: self accelGroup;
+                    yourself.
+        anArray do: [ :each |
+            menu append: each ].
+        ^ menu
+    ]
+
+    statusMessage: aString [
+	<category: 'statusbar'>
+
+	self statusBar
+	    push: 0 text: aString
+    ]
+
+    appendSeparator [
+	<category: 'toolbar'>
+
+	self appendToolItem: GTK.GtkSeparatorToolItem new
+    ]
+
+    appendToolItem: aGtkToolItem [
+	<category: 'toolbar'>
+
+	self toolBar insert: aGtkToolItem pos: -1
+    ]
+
+    appendWidget: aGtkWidget [
+	<category: 'toolbar'>
+
+	self appendToolItem: ((GTK.GtkToolItem new) add: aGtkWidget)
+    ]
+
+    resize: aPoint [
+	<category: 'user interface'>
+
+	window resize: aPoint x height: aPoint y
+    ]
+
+    showAll [
+	{menuBar->false. toolBar->false. centralWidget->true. statusBar->false} do: [ :each |
+	    each key ifNotNil: [ self container 
+		packStart: each key expand: each value fill: true padding: 0 ] ].
+
+	window 
+	    add: self container;
+	    showAll
+    ]
+
+    focusedWidget [
+        <category: 'focus'>
+
+        self subclassResponsibility
+    ]
+
+    onFocusPerform: aSymbol [
+        <category: 'widget'>
+
+        | widget |
+        widget := self focusedWidget.
+        widget isNil ifTrue: [ ^ self ].
+        ^ widget perform: aSymbol
+    ]
+
+    onFocusPerform: aSymbol with: anObject [
+        <category: 'widget'>
+
+        | widget |
+        widget := self focusedWidget.
+        widget isNil ifTrue: [ ^ self ].
+        ^ widget perform: aSymbol with: anObject
+    ]
+]
